﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace RealTimeDataSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DispatcherTimer timer;
        public MainWindow()
        {
            InitializeComponent();
            timer = new DispatcherTimer();
            timer.Start();
            timer.Tick += Timer_Tick; ;
            timer.Interval = new TimeSpan(0, 0, 0, 0, 1500);
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            Random rnd = new Random();
            int indice = (int)sfChart.Series.IndexOf(realtime);
            if (indice < 0)
            {
                realtime.ItemsSource = new RealTimeDataViewModel(); ;
                realtime.XBindingPath = "Speed";
                realtime.YBindingPath = "Rate";
                realtime.Interior = new SolidColorBrush(Colors.DarkGreen);
                sfChart.Series.Add(realtime);
            }
            else
            {
                var findRealTime = (LineSeries)sfChart.Series[indice];
                int index = (findRealTime.ItemsSource as ObservableCollection<RealTimeData>).Count - 1;
                if (index < 0)
                {
                    index = 0;
                    (findRealTime.ItemsSource as ObservableCollection<RealTimeData>).Add(new RealTimeData() { Speed = 1, Rate = rnd.Next(0, 10000) });
                }
                else
                {
                    RealTimeData rtd = (findRealTime.ItemsSource as ObservableCollection<RealTimeData>).Last();
                    (findRealTime.ItemsSource as ObservableCollection<RealTimeData>).Add(new RealTimeData() { Speed = rtd.Speed + 1, Rate = rnd.Next(0, 10000) });
                }
            }
        }
    }

    public class RealTimeData
    {
        public int Speed { get; set; }
        public double Rate { get; set; }
    }

    public class RealTimeDataViewModel
    {
        public ObservableCollection<RealTimeData> RealTimeDatas { get; set; }
        public RealTimeDataViewModel()
        {
            RealTimeDatas = new ObservableCollection<RealTimeData>();
            Random rd = new Random();
            for (int i = 0; i < 100; i++)
            {
                RealTimeDatas.Add(new RealTimeData() { Speed = i, Rate = rd.Next(0, 10000) });
            }
        }
    }
}
